//
//  ClientSocket.h
//  ClientSocket
//
//  Created by fred yu on 8/4/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

//#import "MsgDefine.h"

//返回连接信息
enum SCCInit {
    SCCInitOK = 1,
    SCCInitError_Connected = 2,
	SCCInitError_Host = 4,
	SCCInitError_Port = 8,
	SCCInitError_Delegate = 16,
	SCCInitError_NoConnection = 32,
	SCCInitError_Timeout = 64,
	SCCInitError_NoSocket = 128,
	SCCInitError_Unknown = 256
};
typedef enum SCCInit SCCInit;

#define SCCDefaultConnectionTimeout 30

@interface ClientSocket : NSObject <UIAlertViewDelegate>{
	
@private
	id					delegate;
	NSString*			remoteHost;
	int					remotePort;
	BOOL				isConnected;
	BOOL				hasBeenInitialized;
	BOOL				stayingConnected;
	//BOOL				waitingForReply;
	int					connectionTimeout;
	
	//消息队列
	NSMutableArray*		getSeverArray;
	
	//socket
	CFSocketRef			mCFSocket;
	CFRunLoopSourceRef	source;
	NSFileHandle*		fileHandle;
	int					filedescriptor;
	NSStringEncoding	defaultStringEncoding;
	
	BOOL				IsLastEnd;
	short				thisMsgLenth;
}

@property (retain)NSMutableArray * getSeverArray;

+ (id)client;
+ (id)clientWithHost:(NSString *)initHost port:(int)initPort andDelegate:(id)initDl;
+ (id)clientConnectedTo:(NSString *)initHost onPort:(int)initPort withDelegate:(id)initDl;

- (id)init;
- (id)initWithHost:(NSString *)initHost port:(int)initPort delegate:(id)initDl;

- (SCCInit)connect;
- (void)disconnect;
- (void)NSFileHandlecloseFile;

- (BOOL)sendData:(NSData *)data;
- (BOOL)sendString:(NSString *)string;
- (BOOL)sendString:(NSString *)string withEncoding:(NSStringEncoding)encoding;

- (BOOL)setNewHost:(NSString *)newHost andPort:(int)newPort;
- (BOOL)isConnected;

- (id)delegate;
- (BOOL)setDelegate:(id)newDl;
- (void)setIsConnected:(BOOL)val;
- (NSString *)remoteHost;
- (NSString *)remoteHostName;
- (BOOL)setRemoteHost:(NSString *)newHost;
- (int)remotePort;
- (BOOL)setRemotePort:(int)newPort;
- (BOOL)stayingConnected;
- (void)setStayingConnected:(BOOL)flag;
- (int)connectionTimeout;
- (void)setConnectionTimeout:(int)newTimeout;
- (NSStringEncoding)defaultStringEncoding;
- (void)setDefaultStringEncoding:(NSStringEncoding)encoding;

//解析协议
//- (protocolName) analysisData;

@end